// @param {int} timeout in ms for css animation
function Slides(a) {
	var a  = a,
		t  = undefined,
		l  = undefined,
		li = undefined,
		c  = 0,
		r  = undefined;

	var init = function() {
		var cnr = new Array('a', 'b', 'c', 'd');
		l = document.getElementById('kaleidoscope');
		li = l.getElementsByTagName('li');


		//Set Up The List Elements
		for (var i=0; i<li.length; i++) { 
			var img = li[i].getElementsByTagName('img');

			var new_html = '';
			for (var j=0; j<cnr.length; j++) {
				new_html += '<div class="' + cnr[j] + '">';
				new_html += '<img src="' + img[0].getAttribute('src') + '"></div></a>';
			}

			if(i === 0) {
				li[i].className = 'active ' + animationType();
			}

			li[i].innerHTML = new_html;
		}
		
		//Start the countdown
		startCountdown();		
	};

	var startCountdown = function() {
		h = setTimeout(prepNextSlide, a/2);
		t = setTimeout(showNextSlide, a);
	};

	var prepNextSlide = function() {
		var n = c+1;
		if(n === li.length) {
			n = 0;
		};

		r = animationType();

		if(r==='x-slide' || r==='y-slide' || r==='zoom-out') {
			li[n].className = 'next large';	
		} else {
			li[n].className = 'next';
		}		
	};

	var showNextSlide = function() {
		li[c].className = '';

		c++;
		if(c === li.length) {
			c = 0;
		};

		li[c].className = 'active ' + r;
		startCountdown();
	};

	var animationType = function() {
		var animation_types = new Array('zoom-in', 'zoom-out', 'zoom-in-twist', 'x-slide', 'y-slide');
		return animation_types[Math.floor(Math.random()*animation_types.length)];
	};

	init();
}

window.onload = Slides(10000);